package com.redhat.server.mdb;

import org.apache.log4j.Logger;
import org.quartz.Job;
import org.quartz.JobDataMap;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.JobKey;
 
public class JobA implements Job 
{
	private static final Logger logger = Logger.getLogger(JobA.class);
	
	public JobA()
	{
		super();
	}
	
	public void execute(JobExecutionContext context) throws JobExecutionException 
	{
	    JobKey key = context.getJobDetail().getKey();
	    String group = key.getGroup();
	    String name = key.getName();
	    JobDataMap dataMap = context.getJobDetail().getJobDataMap();

	    String processID = dataMap.getString("brms.processID");
	    long processInstanceID = dataMap.getLong("brms.processInstanceID");
	    int sessionID = dataMap.getInt("brms.sessionID");
	    long taskID = dataMap.getLong("brms.taskID");
	    String taskName = dataMap.getString("brms.taskName");

	    
	    logger.info("Job A is runing");
	    logger.info(name + " " + group);
	    logger.info(processID + " " + processInstanceID + " " + sessionID);
	    logger.info(taskName + " " + taskID);
	}
 
}
