package com.redhat.server.mdb;

import java.util.HashMap;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty; 
import javax.ejb.MessageDriven; 
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException; 
import javax.jms.Message; 
import javax.jms.MessageListener; 


//import javax.jms.Queue;
import org.apache.commons.lang.SerializationUtils;
import org.apache.log4j.Logger;

import com.redhat.messaging.MessageUtils;


@MessageDriven(name = "RelayBean", activationConfig = { 
@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),  
@ActivationConfigProperty(propertyName = "destination", propertyValue = "queue/relayQueue"),  
@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge") }
) 
public class RelayBean extends AbstractProducer implements MessageListener 
{ 
	private static final Logger logger = Logger.getLogger(RelayBean.class);
	
	@Resource(mappedName = "java:/ConnectionFactory") 
	private ConnectionFactory connectionFactory;
	
	@Resource(mappedName = "java:/topic/relayTopic")
	private Destination queue; 
	
	public void onMessage(Message msg)
	{
		try {
			byte[] results = MessageUtils.getBytes(msg);

			@SuppressWarnings("unchecked")
			HashMap<String, Object> hashMap = (HashMap<String, Object>) SerializationUtils.deserialize(results);
			
			logger.info(hashMap.toString());
			
			notifyObservers(hashMap);
			
		} catch (JMSException e) {
			logger.warn("onMessage()", e);
		}   
	}
   
	public Logger getLogger()
	{
		return logger;
	}
	
	public ConnectionFactory getConnectionFactory() throws JMSException
	{
		return connectionFactory;
	}
	

	public Destination getDestination(String callBackQueue) throws JMSException
	{
		return queue;
	}

	public String getResponderName()
	{
		return this.getClass().getName();
	} 

	@Override
	protected String getUserID() 
	{
		return "jboss";
	}

	@Override
	protected String getPassword() 
	{
		return "pass_1234";
	}
}